﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using Syncfusion.Windows.Controls.Grid;

namespace GridDataControlSample
{
    public class GDCAttachedProperty
    {

        public static readonly DependencyProperty DynamicColumnsProperty = DependencyProperty.RegisterAttached(
  "DynamicColumns",
  typeof(List<GridDataVisibleColumn>),
  typeof(GDCAttachedProperty)
  , new FrameworkPropertyMetadata(null, OnDynamicColumnssChanged));

        public static void SetDynamicColumns(UIElement element, List<GridDataVisibleColumn> value)
        {
            element.SetValue(DynamicColumnsProperty, value);
        }
        public static List<GridDataVisibleColumn> GetDynamicColumns(UIElement element)
        {
            return (List<GridDataVisibleColumn>)element.GetValue(DynamicColumnsProperty);
        }

        private static void OnDynamicColumnssChanged(DependencyObject d, DependencyPropertyChangedEventArgs args)
        {
            GridDataControl grid = d as GridDataControl;
           
            if (grid.VisibleColumns != null)
                grid.VisibleColumns.Clear();

            if (args.NewValue == null)
                return;

            var list=((List<GridDataVisibleColumn>)args.NewValue);

            foreach (var item in list)
            {
                grid.VisibleColumns.Add(item);
            }            
        }        
    }
}
