﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using Syncfusion.Windows.Controls.Grid;
using System.Dynamic;

namespace GridDataControlSample
{
    class ViewModel
    {
        public ViewModel()
        {
            this.GDCSource = Getsource();
            this._visiblecolumns = this.Getvisiblecolumn();
        }
        private ObservableCollection<Data> _gdcsource;
        public ObservableCollection<Data> GDCSource
        {
            get { return _gdcsource; }
            set { _gdcsource = value; }
        }   
             
        private List<GridDataVisibleColumn> _visiblecolumns;
        public List<GridDataVisibleColumn> VisibleColumns
        {
            get { return _visiblecolumns; }
            set { _visiblecolumns = value; }
        }

        private List<GridDataVisibleColumn> Getvisiblecolumn()
        {
            List<GridDataVisibleColumn> list = new List<GridDataVisibleColumn>();        

            for (int i = 0; i < 6; i++)
            {
                var bind  = new System.Windows.Data.Binding()
                {
                    Path =new System.Windows.PropertyPath($"ColumnArray[{i}].Text")
                };

                list.Add(new GridDataVisibleColumn()
                {
                    MappingName = $"ColumnArray[{i}].Text",
                    Binding = bind,
                    //Must set this property to let the GridDataControl know the type of property, you are binding when using arrarys
                    VisibleColumnType = typeof(string)
                });
            }
            return list;
        }

        private ObservableCollection<Data> Getsource()
        {            
          ObservableCollection<Data> items = new ObservableCollection<Data>();

            if (items != null)
            {
                for (int i = 0; i < 6; i++)
                {
                    Data data = new Data();
                
                    for (int j = 0; j < 6; j++)
                    {
                        data.ColumnArray[j] = new Model();
                        data.ColumnArray[j].Text = "customer" + i;
                    }
                    items.Add(data);
                }
            }
            return items;
        }
    }
    public class ComboBoxSource : List<string>
    {
        public ComboBoxSource()
        {
            this.Add("Thomas");
            this.Add("Johnson");
            this.Add("Vincent");
            this.Add("Jerald");
            this.Add("Peter");
            this.Add("Vincent");
            this.Add("David");
            this.Add("Peterson");
            this.Add("Robert");
            this.Add("Nestor");

        }
    }
}
